diff --git a/Building/Linux/OSCAR-test.desktop b/Building/Linux/OSCAR-test.desktop
new file mode 100644
index 00000000..46d2045e
--- /dev/null
+++ b/Building/Linux/OSCAR-test.desktop
@@ -0,0 +1,13 @@
+[Desktop Entry]
+Version=1.1
+Name=OSCAR-test
+GenericName=CPAP Reporter
+TryExec=OSCAR-test
+Exec=OSCAR-test
+Terminal=false
+Icon=/usr/share/icons/hicolor/48x48/apps/OSCAR-test.png
+Type=Application
+Categories=Science;Education;
+StartupNotify=true
+X-GNOME-UsesNotifications=true
+Name[en_CA]=OSCAR-test
diff --git a/Building/Linux/OSCAR-test.png b/Building/Linux/OSCAR-test.png
new file mode 100644
index 00000000..24d19b91
Binary files /dev/null and b/Building/Linux/OSCAR-test.png differ
diff --git a/Building/Linux/OSCAR-test.svg b/Building/Linux/OSCAR-test.svg
new file mode 100644
index 00000000..832d2bca
--- /dev/null
+++ b/Building/Linux/OSCAR-test.svg
@@ -0,0 +1,63 @@
+
+
+
+
diff --git a/Building/Linux/OSCAR.desktop b/Building/Linux/OSCAR.desktop
index 31d08ce8..f4c67ee0 100755
--- a/Building/Linux/OSCAR.desktop
+++ b/Building/Linux/OSCAR.desktop
@@ -5,7 +5,11 @@ GenericName=CPAP Reporter
TryExec=OSCAR
Exec=OSCAR
Terminal=false
-Icon=/opt/OSCAR/OSCAR.png
+Icon=/usr/share/icons/hicolor/48x48/apps/OSCAR.png
Type=Application
-Categories=Education,Science,MedicalSoftware
+Categories=Education;Science;
+StartupNotify=true
+X-GNOME-UsesNotifications=true
+Name[en_CA]=OSCAR-test
+
diff --git a/Building/Linux/OSCAR.png b/Building/Linux/OSCAR.png
index b992e0eb..24d19b91 100644
Binary files a/Building/Linux/OSCAR.png and b/Building/Linux/OSCAR.png differ
diff --git a/Building/Linux/OSCAR.svg b/Building/Linux/OSCAR.svg
new file mode 100644
index 00000000..832d2bca
--- /dev/null
+++ b/Building/Linux/OSCAR.svg
@@ -0,0 +1,63 @@
+
+
+
+
diff --git a/Building/Linux/clean_rm-test.sh b/Building/Linux/clean_rm-test.sh
new file mode 100755
index 00000000..f8f6002e
--- /dev/null
+++ b/Building/Linux/clean_rm-test.sh
@@ -0,0 +1,34 @@
+#! /bin/bash
+set -e
+
+#we need to rm files that have been copied via script
+rep="/usr/share/icons/OSCAR_beta"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/local/share/icons/OSCAR-test"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/share/doc/OSCAR_beta"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/local/share/doc/OSCAR-test"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/share/OSCAR_beta"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/local/share/OSCAR-test"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
diff --git a/Building/Linux/clean_rm.sh b/Building/Linux/clean_rm.sh
new file mode 100755
index 00000000..50db903d
--- /dev/null
+++ b/Building/Linux/clean_rm.sh
@@ -0,0 +1,19 @@
+#! /bin/bash
+set -e
+
+#we need to rm files that have been copied via script
+rep="/usr/share/icons/OSCAR"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/share/doc/OSCAR"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
+rep="/usr/share/OSCAR"
+if [ -d "$rep" ]; then
+ rm -r $rep
+fi
+
diff --git a/Building/Linux/ln_usrbin-test.sh b/Building/Linux/ln_usrbin-test.sh
new file mode 100755
index 00000000..2f522f17
--- /dev/null
+++ b/Building/Linux/ln_usrbin-test.sh
@@ -0,0 +1,67 @@
+#! /bin/bash
+set -e
+#
+# modify by untoutseul05 to search local name for Desktop Folder
+# the package now suits the fhs
+
+# application name
+appli_name="OSCAR-test"
+
+# binary copy flag
+copy_flag=0
+
+# Select the binary file for the goog version of QT (5.7 ou 5.9)
+#echo "test the version of qt5 core version"
+
+if [ -f "/etc/redhat-release" ]; then
+ # pour mageia (red hat)
+ echo "distribution : mageia (red hat)"
+ Qt5_core=$(yum search -q qt5core5 | awk '{print $1}' | grep lib | sort -u)
+ MajorVer_no=$(yum info $Qt5_core | grep -i "version" | awk '{print $3}' | awk -F. '{print $1}')
+ MinorVer_no=$(yum info $Qt5_core | grep -i "version" | awk '{print $3}' | awk -F. '{print $2}')
+
+elif [ -f "/etc/lsb-release" ] || [ -f "/etc/debian_version" ]; then
+ # pour debian
+# echo "distribution : debian"
+ Qt5_core=$(dpkg -l | awk '{print $2}'| grep qt5 | grep core | awk -F: '{print $1}')
+ Major_ver=$(dpkg -l | grep $Qt5_core | awk '{print $3}' | awk -F. '{print $1}')
+ Minor_ver=$(dpkg -l | grep $Qt5_core | awk '{print $3}' | awk -F. '{print $2}')
+else
+ echo "unknown distribution "
+ exit
+fi
+
+#echo "Qt5_core = '$Qt5_core'"
+#echo "Major_ver = $Major_ver"
+#echo "Minor_ver = $Minor_ver"
+
+if [ -x /usr/bin/update-menus ]; then update-menus; fi
+
+if [ ! -z "$SUDO_USER" ]; then
+ # find real name of the Desktop folder (Bureau for xubuntu french version)
+ desktop_folder_name="/home/$SUDO_USER/Desktop"
+
+ # si doesn't exist, try to find it translated name
+ tmp_dir=""
+ if [ ! -d "$desktop_folder_name" ]; then
+ tmp_dir=`cat /home/$SUDO_USER/.config/user-dirs.dirs | grep XDG_DESKTOP_DIR | awk -F= '{print $2}' | awk -F\" '{print $2}' | awk -F\/ '{print $2}'`
+ fi
+
+ # don't overwrite if translated name or doesn't exist
+ if [ -n "$tmp_dir" ]; then
+ # calculate the full folder
+ tmp_dir_full="/home/${SUDO_USER}/${tmp_dir}"
+ if [ -d "$tmp_dir_full" ]; then
+ desktop_folder_name=$tmp_dir_full
+ fi
+ fi
+
+ # info : /usr/share/applications/${appli_name}.desktop
+ # copy icon file to the Desktop folder (even if it has been translated)
+ file_from="/usr/share/applications/${appli_name}.desktop"
+ file_to="$desktop_folder_name/${appli_name}.desktop"
+
+ cp $file_from $file_to
+ chown $SUDO_USER:$SUDO_USER $file_to
+ chmod a+x $file_to
+fi
diff --git a/Building/Linux/ln_usrbin.sh b/Building/Linux/ln_usrbin.sh
new file mode 100755
index 00000000..a8946424
--- /dev/null
+++ b/Building/Linux/ln_usrbin.sh
@@ -0,0 +1,70 @@
+#! /bin/bash
+set -e
+#
+# modify by untoutseul05 to search local name for Desktop Folder
+# the package now suits the fhs
+
+# application name
+appli_name="OSCAR"
+
+# binary copy flag
+copy_flag=0
+
+# Select the binary file for the goog version of QT (5.7 ou 5.9)
+echo "test the version of qt5 core version"
+
+if [ -f "/etc/redhat-release" ]; then
+ # pour mageia (red hat)
+ echo "distribution : mageia (red hat)"
+ nom_core=$(yum search -q qt5core5 | awk '{print $1}' | grep lib | sort -u)
+ no_vermaj=$(yum info $nom_core | grep -i "version" | awk '{print $3}' | awk -F. '{print $1}')
+ no_vermin=$(yum info $nom_core | grep -i "version" | awk '{print $3}' | awk -F. '{print $2}')
+
+elif [ -f "/etc/lsb-release" ] || [ -f "/etc/debian_version" ]; then
+ # pour debian
+ echo "distribution : debian"
+ nom_core=$(dpkg -l | awk '{print $2}'| grep qt5 | grep core | awk -F: '{print $1}')
+ no_vermaj=$(dpkg -l | grep $nom_core | awk '{print $3}' | awk -F. '{print $1}')
+ no_vermin=$(dpkg -l | grep $nom_core | awk '{print $3}' | awk -F. '{print $2}')
+else
+ echo "unknown distribution "
+ exit
+fi
+
+echo "QT5_core = '$nom_core'"
+echo "Major ver = $no_vermaj"
+echo "Minor ver = $no_vermin"
+
+if [ -x /usr/bin/update-menus ]; then update-menus; fi
+
+if [ X_$SUDO_USER != "X_" ]; then
+ # find real name of the Desktop folder (Bureau for xubuntu french version)
+ desktop_folder_name="/home/$SUDO_USER/Desktop"
+
+ # si doesn't exist, try to find it translated name
+ tmp_dir=""
+ if [ ! -d "$desktop_folder_name" ]; then
+ tmp_dir=`cat /home/$SUDO_USER/.config/user-dirs.dirs | grep XDG_DESKTOP_DIR | awk -F= '{print $2}' | awk -F\" '{print $2}' | awk -F\/ '{print $2}'`
+ fi
+
+ # don't overwrite if translated name or doesn't exist
+ if [ -n "$tmp_dir" ]; then
+ # calculate the full folder
+ tmp_dir_full="/home/${SUDO_USER}/${tmp_dir}"
+ if [ -d "$tmp_dir_full" ]; then
+ desktop_folder_name=$tmp_dir_full
+ fi
+ fi
+
+ # info : /usr/share/applications/${appli_name}.desktop
+ # copy icon file to the Desktop folder (even if it has been translated)
+ file_from="/usr/share/applications/${appli_name}.desktop"
+ file_to="$desktop_folder_name/${appli_name}.desktop"
+
+ cp $file_from $file_to
+
+ if [ -f "$file_to" ]; then
+ chown $SUDO_USER:$SUDO_USER $file_to
+ chmod a+x $file_to
+ fi
+fi
diff --git a/Building/Linux/mkDebian9.sh b/Building/Linux/mkDebian9.sh
index a57bab7c..b843168c 100755
--- a/Building/Linux/mkDebian9.sh
+++ b/Building/Linux/mkDebian9.sh
@@ -1,47 +1,142 @@
#! /bin/bash
+# First parameter is version number - (ex: 1.0.0)
+# Second parametr is build or release status - (ex: test, beta, or release)
+# Third parameter is optional
#
-# First (optional) parameter is package version (ex: "1")
-#
-# This generally should start at 1 for each VERSION and increment any time the
-# package needs to be updated.
-#
-# see https://serverfault.com/questions/604541/debian-packages-version-convention
-ITERATION=$1
-[[ ${ITERATION} == ""] && ITERATION="1"
-
-SRC=./OSCAR-code
-
-VERSION=`awk '/#define VERSION / { gsub(/"/, "", $3); print $3 }' ${SRC}/VERSION
-if [[ VERSION == *-* ]]; then
- # Use ~ for prerelease information so that it sorts correctly compared to release
- # versions. See https://www.debian.org/doc/debian-policy/ch-controlfields.html#version
- IFS="-" read -r VERSION PRERELEASE <<< ${VERSION}
- VERSION="${VERSION}~${PRERELEASE}"
+if [ -z "$1" ]; then
+ echo "1st parameter must be the version number (x.y.z)"
+ exit
fi
-GIT_REVISION=`awk '/#define GIT_REVISION / { gsub(/"/, "", $3); print $3 }' ${SRC}/git_info.h`
-rm -r tempDir
-mkdir tempDir
-cp build/oscar/OSCAR tempDir
-cp -r build/oscar/Help tempDir
-cp -r build/oscar/Html tempDir
-cp -r build/oscar/Translations tempDir
-cp OSCAR.png tempDir
-cp OSCAR.desktop tempDir
-#cp OSCAR-code/migration.sh tempDir
-#
+if [ "$2" != "test" ] && [ "$2" != "beta" ] && [ "$2" != "release" ]; then
+ echo "2nd parameter must be 'test' or 'beta' or 'release'."
+ exit
+fi
+
+# application name
+appli_name="OSCAR"
+pre_inst="tst_user.sh"
+post_inst="ln_usrbin.sh"
+pre_rem="rm_usrbin.sh"
+post_rem="clean_rm.sh"
+iter=""
+# build folder (absolute path is better)
+build_folder="/home/$USER/OSCAR/build"
+if [ "$2" != "release" ]; then
+ appli_name=${appli_name}-test
+ post_inst="ln_usrbin-test.sh"
+ pre_rem="rm_usrbin-test.sh"
+ post_rem="clean_rm-test.sh"
+ iter="$2"
+fi
+if [ -n "$3" ]; then
+ iter="$iter"~"$3"
+fi
+
+# temporary folder (absolute path is better)
+temp_folder="/home/$USER/tmp_deb_${appli_name}/"
+
+# destination folder in the .deb file
+dest_folder="/usr/"
+
+# the .deb file mustn't exist (or fpm must have -f parameter to force the creation)
+archi_tmp=$(lscpu | grep -i architecture | awk -F: {'print $2'} | tr -d " ")
+if [ "$archi_tmp" = "x86_64" ];then
+ archi="amd64"
+else
+ archi="unknown"
+fi
+deb_file="${appli_name}_$1-$2_$archi.deb"
+
+# if deb file exists, fatal error
+if [ -f "./$deb_file" ]; then
+ echo "destination file (./$deb_file) exists. fatal error"
+ exit
+fi
+
+# clean folders need to create the package
+if [ -d "${temp_folder}" ]; then
+ rm -r ${temp_folder}
+fi
+mkdir ${temp_folder}
+if [ ! -d "${temp_folder}" ]; then
+ echo "Folder (${temp_folder}) not created : fatal error."
+ exit
+fi
+chmod 0755 ${temp_folder}
+# save current value of umask (for u=g and not g=o)
+current_value=$(umask)
+umask 022
+mkdir ${temp_folder}/bin
+mkdir ${temp_folder}/share
+mkdir ${temp_folder}/share/${appli_name}
+mkdir ${temp_folder}/share/doc
+share_doc_folder="${temp_folder}/share/doc/${appli_name}"
+mkdir ${share_doc_folder}
+mkdir ${temp_folder}/share/icons
+mkdir ${temp_folder}/share/icons/hicolor
+mkdir ${temp_folder}/share/icons/hicolor/48x48
+mkdir ${temp_folder}/share/icons/hicolor/48x48/apps
+mkdir ${temp_folder}/share/icons/hicolor/scalable
+mkdir ${temp_folder}/share/icons/hicolor/scalable/apps
+mkdir ${temp_folder}/share/applications
+
+# must delete debug symbol in OSCAR binary file
+# --- V1
+strip -s -o ${temp_folder}/bin/${appli_name} ${build_folder}/oscar/OSCAR
+#old code : cp ${build_folder}/oscar/OSCAR ${temp_folder}/bin
+
+# 2>/dev/null : errors does not appear : we don't care about them
+cp -r ${build_folder}/oscar/Help ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Html ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Translations ${temp_folder}/share/${appli_name} 2>/dev/null
+cp ./${appli_name}.png ${temp_folder}/share/icons/hicolor/48x48/apps/${appli_name}.png
+cp ./${appli_name}.svg ${temp_folder}/share/icons/hicolor/scalable/apps/${appli_name}.svg
+cp ./${appli_name}.desktop ${temp_folder}/share/applications/${appli_name}.desktop
+
+echo "Copyright 2019 nightowlsoftware.ca " > $share_doc_folder/copyright
+
+changelog_file="$share_doc_folder/changelog"
+
+#automatic changelog as a bad name
+# need to generate one and say fpm to use it instead of create one
+# it seems that it needs both of them...
+
+# creation of the changelog.Debian.gz
+echo "$appli_name ($1-$2) whatever; urgency=medium" > $changelog_file
+echo "" >> $changelog_file
+echo " * Package created with FPM." >> $changelog_file
+echo "" >> $changelog_file
+echo " -- nightowlsoftware.ca " >> $changelog_file
+# -- Sat, 03 Aug 2019 15:22:22 +0200
+gzip --best $changelog_file
+description='Open Source CPAP Analysis Reporter\n'
+# trick for dummies : need to use echo -e to take care of \n (cariage return to slip description and extra one
+description=$(echo -e $description)
+
+# restore umask value
+umask $current_value
+
+# create the .deb file (litian test show juste a warning with a man that doesn't exists : don't care about that)
fpm --input-type dir --output-type deb \
- --prefix /opt \
- --after-install ln_usrlocalbin.sh \
- --before-remove rm_usrlocalbin.sh \
- --name oscar --version ${VERSION} --iteration ${ITERATION} \
- --category Other \
- --maintainer oscar@nightowlsoftwre.ca \
+ --prefix ${dest_folder} \
+ --before-install ${pre_inst} \
+ --after-install ${post_inst} \
+ --before-remove ${pre_rem} \
+ --after-remove ${post_rem} \
+ --name ${appli_name} --version $1 --iteration $iter \
+ --category misc \
+ --deb-priority optional \
+ --maintainer " -- nightowlsoftware.ca " \
--license GPL-v3 \
--vendor nightowlsoftware.ca \
- --description "Open Sourece CPAP Analysis Reporter" \
+ --description "$description" \
--url https://sleepfiles.com/OSCAR \
+ --deb-no-default-config-files \
+ --depends libdouble-conversion1 \
+ --depends libpcre16-3 \
+ --depends qttranslations5-l10n \
--depends 'libqt5core5a > 5.7.0' \
--depends libqt5serialport5 \
--depends libqt5xml5 \
@@ -52,5 +147,8 @@ fpm --input-type dir --output-type deb \
--depends libqt5printsupport5 \
--depends libglu1-mesa \
--depends libgl1 \
- --deb-no-default-config-files \
- tempDir
+ --depends libc6 \
+ --no-deb-generate-changes \
+ -C ${temp_folder} \
+ .
+
diff --git a/Building/Linux/mkRedHat.sh b/Building/Linux/mkRedHat.sh
new file mode 100755
index 00000000..b53a1d60
--- /dev/null
+++ b/Building/Linux/mkRedHat.sh
@@ -0,0 +1,118 @@
+#! /bin/bash
+# First parameter is version number - (ex: 1.0.0)
+# Second parametr is build or release status - (ex: beta or release)
+#
+
+# application name
+appli_name="OSCAR"
+# build folder (absolute path is better)
+build_folder="/home/$USER/OSCAR/build"
+# temporary folder (absolute path is better)
+temp_folder="/home/$USER/tmp_RH_${appli_name}/"
+chmod 775 $temp_folder
+
+# destination folder in the .rpm file
+dest_folder="/usr/"
+
+if [ -z "$1" ]; then
+ echo "1st parameter must be the version number (x.y.z)"
+ exit
+fi
+
+if [ "$2" != "beta" ] && [ "$2" != "release" ]; then
+ echo "2nd parameter must 'beta' or 'release'."
+ exit
+fi
+
+# the .rpm file mustn't exist (or fpm must have -f parameter to force the creation)
+archi=$(lscpu | grep -i architecture | awk -F: {'print $2'} | tr -d " ")
+rpm_file="${appli_name}-$1-$2.$archi.rpm"
+
+# if rpm file exists, fatal error
+if [ -f "./$rpm_file" ]; then
+ echo "destination file (./$rpm_file) exists. fatal error"
+ exit
+fi
+
+# clean folders need to create the package
+if [ -d "${temp_folder}" ]; then
+ rm -r ${temp_folder}
+fi
+mkdir ${temp_folder}
+if [ ! -d "${temp_folder}" ]; then
+ echo "Folder (${temp_folder}) not created : fatal error."
+ exit
+fi
+chmod 0755 ${temp_folder}
+# save current value of umask (for u=g and not g=o)
+current_value=$(umask)
+umask 022
+mkdir ${temp_folder}/bin
+mkdir ${temp_folder}/share
+mkdir ${temp_folder}/share/${appli_name}
+mkdir ${temp_folder}/share/doc
+share_doc_folder="${temp_folder}/share/doc/${appli_name}"
+mkdir ${share_doc_folder}
+mkdir ${temp_folder}/share/icons
+mkdir ${temp_folder}/share/icons/${appli_name}
+mkdir ${temp_folder}/share/applications
+
+# must delete debug symbol in OSCAR binary file
+# -- V1 :
+strip -s -o ${temp_folder}/bin/${appli_name} ${build_folder}/oscar/OSCAR
+#old code : cp ${build_folder}/oscar/OSCAR ${temp_folder}/bin
+
+# for QT5.7
+# strip -s -o ${temp_folder}/bin/oscar.qt5.7 ./oscar.qt5.7
+# for QT5.9
+# strip -s -o ${temp_folder}/bin/oscar.qt5.9 ./oscar.qt5.9
+
+# 2>/dev/null : errors does not appear : we don't care about them
+cp -r ${build_folder}/oscar/Help ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Html ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Translations ${temp_folder}/share/${appli_name} 2>/dev/null
+cp ./OSCAR.png ${temp_folder}/share/icons/${appli_name}/${appli_name}.png
+cp ./OSCAR.desktop ${temp_folder}/share/applications/${appli_name}.desktop
+
+echo "Copyright 2019 nightowlsoftware.ca " > $share_doc_folder/copyright
+
+changelog_file="$share_doc_folder/changelog"
+
+#automatic changelog as a bad name
+# need to generate one and say fpm to use it instead of create one
+# it seems that it needs both of them...
+
+# creation of the changelog.Debian.gz (for rpm package ? )
+echo "$appli_name ($1-$2) whatever; urgency=medium" > $changelog_file
+echo "" >> $changelog_file
+echo " * Package created with FPM." >> $changelog_file
+echo "" >> $changelog_file
+echo " -- nightowlsoftware.ca " >> $changelog_file
+# -- Sat, 03 Aug 2019 15:22:22 +0200
+gzip --best $changelog_file
+
+description='Open Source CPAP Analysis Reporter\n'
+# trick for dummies : need to use echo -e to take care of \n (cariage return to slip description and extra one
+description=$(echo -e $description)
+
+# restore umask value
+umask $current_value
+
+# create the .rpm file (litian test show juste a warning with a man that doesn't exists : don't care about that)
+# pour 32bit : i686 au lieu de x86_64
+fpm --input-type dir --output-type rpm \
+ --prefix ${dest_folder} \
+ --after-install ln_usrbin.sh \
+ --before-remove rm_usrbin.sh \
+ --after-remove clean_rm.sh \
+ --name ${appli_name} --version $1 --iteration $2 \
+ --category misc \
+ --maintainer " -- nightowlsoftware.ca " \
+ --license GPL-v3 \
+ --vendor nightowlsoftware.ca \
+ --description "$description" \
+ --url https://sleepfiles.com/OSCAR \
+ -C ${temp_folder} \
+ .
+
+
diff --git a/Building/Linux/mkUbuntu.sh b/Building/Linux/mkUbuntu.sh
new file mode 100755
index 00000000..df6558bd
--- /dev/null
+++ b/Building/Linux/mkUbuntu.sh
@@ -0,0 +1,153 @@
+#! /bin/bash
+# First parameter is version number - (ex: 1.0.0)
+# Second parametr is build or release status - (ex: test, beta, or release)
+# Third parameter is optional
+#
+
+if [ -z "$1" ]; then
+ echo "1st parameter must be the version number (x.y.z)"
+ exit
+fi
+
+if [ "$2" != "test" ] && [ "$2" != "beta" ] && [ "$2" != "release" ]; then
+ echo "2nd parameter must be 'test' or 'beta' or 'release'."
+ exit
+fi
+
+# application name
+appli_name="OSCAR"
+pre_inst="tst_user.sh"
+post_inst="ln_usrbin.sh"
+pre_rem="rm_usrbin.sh"
+post_rem="clean_rm.sh"
+iter=""
+# build folder (absolute path is better)
+build_folder="/home/$USER/OSCAR/build"
+if [ "$2" != "release" ]; then
+ appli_name=${appli_name}-test
+ post_inst="ln_usrbin-test.sh"
+ pre_rem="rm_usrbin-test.sh"
+ post_rem="clean_rm-test.sh"
+ iter="$2"
+fi
+if [ -n "$3" ]; then
+ iter="$iter"~"$3"
+fi
+# temporary folder (absolute path is better)
+temp_folder="/home/$USER/tmp_Ubu_${appli_name}/"
+
+# destination folder in the .deb file
+dest_folder="/usr/"
+
+# the .deb file mustn't exist (or fpm must have -f parameter to force the creation)
+archi_tmp=$(lscpu | grep -i architecture | awk -F: {'print $2'} | tr -d " ")
+if [ "$archi_tmp" = "x86_64" ];then
+ archi="amd64"
+else
+ archi="unknown"
+fi
+deb_file="${appli_name}_$1-$2_$archi.deb"
+
+# if deb file exists, fatal error
+if [ -f "./$deb_file" ]; then
+ echo "destination file (./$deb_file) exists. fatal error"
+ exit
+fi
+
+# clean folders need to create the package
+if [ -d "${temp_folder}" ]; then
+ rm -r ${temp_folder}
+fi
+mkdir ${temp_folder}
+if [ ! -d "${temp_folder}" ]; then
+ echo "Folder (${temp_folder}) not created : fatal error."
+ exit
+fi
+chmod 0755 ${temp_folder}
+# save current value of umask (for u=g and not g=o)
+current_value=$(umask)
+umask 022
+mkdir ${temp_folder}/bin
+mkdir ${temp_folder}/share
+mkdir ${temp_folder}/share/${appli_name}
+mkdir ${temp_folder}/share/doc
+share_doc_folder="${temp_folder}/share/doc/${appli_name}"
+mkdir ${share_doc_folder}
+mkdir ${temp_folder}/share/icons
+mkdir ${temp_folder}/share/icons/hicolor
+mkdir ${temp_folder}/share/icons/hicolor/48x48
+mkdir ${temp_folder}/share/icons/hicolor/48x48/apps
+mkdir ${temp_folder}/share/icons/hicolor/scalable
+mkdir ${temp_folder}/share/icons/hicolor/scalable/apps
+mkdir ${temp_folder}/share/applications
+
+# must delete debug symbol in OSCAR binary file
+# --- V1
+strip -s -o ${temp_folder}/bin/${appli_name} ${build_folder}/oscar/OSCAR
+#old code : cp ${build_folder}/oscar/OSCAR ${temp_folder}/bin
+
+# 2>/dev/null : errors does not appear : we don't care about them
+cp -r ${build_folder}/oscar/Help ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Html ${temp_folder}/share/${appli_name} 2>/dev/null
+cp -r ${build_folder}/oscar/Translations ${temp_folder}/share/${appli_name} 2>/dev/null
+cp ./${appli_name}.png ${temp_folder}/share/icons/hicolor/48x48/apps/${appli_name}.png
+cp ./${appli_name}.svg ${temp_folder}/share/icons/hicolor/scalable/apps/${appli_name}.svg
+cp ./${appli_name}.desktop ${temp_folder}/share/applications/${appli_name}.desktop
+
+echo "Copyright 2019 nightowlsoftware.ca " > $share_doc_folder/copyright
+
+changelog_file="$share_doc_folder/changelog"
+
+#automatic changelog as a bad name
+# need to generate one and say fpm to use it instead of create one
+# it seems that it needs both of them...
+
+# creation of the changelog.Debian.gz
+echo "$appli_name ($1-$2) whatever; urgency=medium" > $changelog_file
+echo "" >> $changelog_file
+echo " * Package created with FPM." >> $changelog_file
+echo "" >> $changelog_file
+echo " -- nightowlsoftware.ca " >> $changelog_file
+# -- Sat, 03 Aug 2019 15:22:22 +0200
+gzip --best $changelog_file
+description='Open Source CPAP Analysis Reporter\n'
+# trick for dummies : need to use echo -e to take care of \n (cariage return to slip description and extra one
+description=$(echo -e $description)
+
+# restore umask value
+umask $current_value
+
+# create the .deb file (litian test show juste a warning with a man that doesn't exists : don't care about that)
+fpm --input-type dir --output-type deb \
+ --prefix ${dest_folder} \
+ --before-install ${pre_inst} \
+ --after-install ${post_inst} \
+ --before-remove ${pre_rem} \
+ --after-remove ${post_rem} \
+ --name ${appli_name} --version $1 --iteration $iter \
+ --category misc \
+ --deb-priority optional \
+ --maintainer " -- nightowlsoftware.ca " \
+ --license GPL-v3 \
+ --vendor nightowlsoftware.ca \
+ --description "$description" \
+ --url https://sleepfiles.com/OSCAR \
+ --deb-no-default-config-files \
+ --depends libdouble-conversion1 \
+ --depends libpcre16-3 \
+ --depends qttranslations5-l10n \
+ --depends 'libqt5core5a > 5.9.0' \
+ --depends libqt5serialport5 \
+ --depends libqt5xml5 \
+ --depends libqt5network5 \
+ --depends libqt5gui5 \
+ --depends libqt5widgets5 \
+ --depends libqt5opengl5 \
+ --depends libqt5printsupport5 \
+ --depends libglu1-mesa \
+ --depends libgl1 \
+ --depends libc6 \
+ --no-deb-generate-changes \
+ -C ${temp_folder} \
+ .
+
diff --git a/Building/Linux/rm_usrbin-test.sh b/Building/Linux/rm_usrbin-test.sh
new file mode 100755
index 00000000..4bc6f24a
--- /dev/null
+++ b/Building/Linux/rm_usrbin-test.sh
@@ -0,0 +1,42 @@
+#! /bin/bash
+#
+# no error is permitted
+set -e
+
+# application name
+appli_name="OSCAR-test"
+
+if [ ! -z "$SUDO_USER" ]; then
+ # find real name of the Desktop folder (Bureau for xubuntu french version)
+ desktop_folder_name="/home/$SUDO_USER/Desktop"
+
+ # si doesn't exist, try to find it translated name
+ tmp_dir=""
+ if [ ! -d "$desktop_folder_name" ]; then
+ tmp_dir=`cat /home/$SUDO_USER/.config/user-dirs.dirs | grep XDG_DESKTOP_DIR | awk -F= '{print $2}' | awk -F\" '{print $2}' | awk -F\/ '{print $2}'`
+ fi
+
+ # don't overwrite if tmp_dir empty or doesn't exist
+ if [ -n "$tmp_dir" ]; then
+ # calculate the full folder
+ tmp_dir_full="/home/${SUDO_USER}/${tmp_dir}"
+ if [ -d "$tmp_dir_full" ]; then
+ desktop_folder_name=$tmp_dir_full
+ fi
+ fi
+
+ file="$desktop_folder_name/${appli_name}.desktop"
+ if [ -f "$file" ]; then
+ rm $file
+ fi
+fi
+
+# clean the destination folder
+file="/usr/local/bin/${appli_name}"
+if [ -f "$file" ]; then
+ rm $file
+fi
+
+if [ -x /usr/bin/update-menus ]; then update-menus; fi
+
+
diff --git a/Building/Linux/rm_usrbin.sh b/Building/Linux/rm_usrbin.sh
new file mode 100755
index 00000000..cbaaae73
--- /dev/null
+++ b/Building/Linux/rm_usrbin.sh
@@ -0,0 +1,95 @@
+#! /bin/bash
+#
+# no error is permitted
+set -e
+
+# application name
+appli_name="OSCAR"
+
+if [ X_$SUDO_USER != "X_" ]; then
+ # find real name of the Desktop folder (Bureau for xubuntu french version)
+ desktop_folder_name="/home/$SUDO_USER/Desktop"
+
+ # si doesn't exist, try to find it translated name
+ tmp_dir=""
+ if [ ! -d "$desktop_folder_name" ]; then
+ tmp_dir=`cat /home/$SUDO_USER/.config/user-dirs.dirs | grep XDG_DESKTOP_DIR | awk -F= '{print $2}' | awk -F\" '{print $2}' | awk -F\/ '{print $2}'`
+ fi
+
+ # don't overwrite if tmp_dir empty or doesn't exist
+ if [ -n "$tmp_dir" ]; then
+ # calculate the full folder
+ tmp_dir_full="/home/${SUDO_USER}/${tmp_dir}"
+ if [ -d "$tmp_dir_full" ]; then
+ desktop_folder_name=$tmp_dir_full
+ fi
+ fi
+
+ file="$desktop_folder_name/${appli_name}.desktop"
+ if [ -f "$file" ]; then
+ rm $file
+ fi
+fi
+
+# clean destination folders (bin + shortcut) + move from /opt/OSCAR (if exists)
+
+if [ -d "/opt/OSCAR" ]; then
+ # --- old folder exists : move files to the new folder ---
+ # Help folder
+ folder_from="/opt/OSCAR/Help"
+ folder_to="/usr/share/${appli_name}"
+ if [ -d "$folder_from" ]; then
+ mkdir -p $folder_to
+ mv $folder_from $folder_to
+ fi
+ # Html folder
+ folder_from="/opt/OSCAR/Html"
+ folder_to="/usr/share/${appli_name}"
+ if [ -d "$folder_from" ]; then
+ mkdir -p $folder_to
+ mv $folder_from $folder_to
+ fi
+ # Translations folder
+ folder_from="/opt/OSCAR/Translations"
+ folder_to="/usr/share/${appli_name}"
+ if [ -d "$folder_from" ]; then
+ mkdir -p $folder_to
+ mv $folder_from $folder_to
+ fi
+ # icon file : OSCAR.png
+ file="/opt/OSCAR/OSCAR.png"
+ folder_to="/usr/share/icons/${appli_name}"
+ if [ -f "$file" ]; then
+ mkdir -p $folder_to
+ mv $file ${folder_to}/${appli_name}.png
+ fi
+ # shortcut file : OSCAR.desktop
+ file="/opt/OSCAR/OSCAR.desktop"
+ folder_to="/usr/share/applications/${appli_name}"
+ if [ -f "$file" ]; then
+ mkdir -p $folder_to
+ mv $file ${folder_to}/${appli_name}.desktop
+ fi
+
+ # what is the purpose of saving the binary file ?
+ # binary file : OSCAR (in /tmp + minimize the name [oscar instead of OSCAR])
+ #file="/opt/OSCAR/OSCAR"
+ #folder_to="/tmp/${appli_name}"
+ #if [ -f "$file" ]; then
+ # mkdir -p $folder_to
+ # mv $file ${folder_to}/${appli_name}
+ #fi
+
+ # folder /opt can be deleted
+ rm -R /opt/OSCAR
+fi
+
+# clean the destination folder
+file="/usr/bin/${appli_name}"
+if [ -f "$file" ]; then
+ rm $file
+fi
+
+if [ -x /usr/bin/update-menus ]; then update-menus; fi
+
+
diff --git a/Building/Linux/tst_user.sh b/Building/Linux/tst_user.sh
new file mode 100755
index 00000000..85a47110
--- /dev/null
+++ b/Building/Linux/tst_user.sh
@@ -0,0 +1,10 @@
+#! /bin/bash
+#set -e
+#
+#test USER (must be root) vs SUDO_USER (must be other than root but not empty)
+#if [ "$USER" != "root" ] || [ "$SUDO_USER" = "root" ] || [ -z "$SUDO_USER" ]; then
+# echo "dpkg -i must be launched as normal user with sudo command. fatal error"
+# exit
+#fi
+# do nothing
+